<?php
/* Prevent direct access */
defined('ABSPATH') or die("You can't access this file directly.");

if (!class_exists("asp_statistics")) {
    /**
     * Class asp_statistics
     *
     * Statistics controller class
     */
    class asp_statistics {
        static function addKeyword($id, $s) {
            global $wpdb;

            if (isset($wpdb->base_prefix)) {
                $_prefix = $wpdb->base_prefix;
            } else {
                $_prefix = $wpdb->prefix;
            }
            require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
            $in = $wpdb->query(
                $wpdb->prepare(
                    "UPDATE " . $_prefix . "ajaxsearchpro_statistics SET num=num+1, last_date=%d WHERE (keyword='%s' AND search_id=%d)",
                    time(),
                    strip_tags($s),
                    $id
                )
            );
            if ($in == false) {
                return $wpdb->query(
                    $wpdb->prepare(
                        "INSERT INTO " . $_prefix . "ajaxsearchpro_statistics (search_id, keyword, num, last_date) VALUES (%d, '%s', 1, %d)",
                        $id,
                        strip_tags($s),
                        time()
                    )
                );
            }
            return $in;
        }

        static function getTop($count, $id="") {
            global $wpdb;

            if (isset($wpdb->base_prefix)) {
                $_prefix = $wpdb->base_prefix;
            } else {
                $_prefix = $wpdb->prefix;
            }
            $where = "";
            if ( $id != "" )
                $where = " WHERE search_id=" . ( $id + 0 );

            return $wpdb->get_results(
                "SELECT * FROM " . $_prefix . "ajaxsearchpro_statistics " . $where . " ORDER BY num DESC LIMIT ".($count + 0)
                ,ARRAY_A
            );
        }

        static function getLast($count, $id="") {
            global $wpdb;

            if (isset($wpdb->base_prefix)) {
                $_prefix = $wpdb->base_prefix;
            } else {
                $_prefix = $wpdb->prefix;
            }
            $where = "";
            if ( $id != "" )
                $where = " WHERE search_id=" . ( $id + 0 );

            return $wpdb->get_results(
                "SELECT * FROM " . $_prefix . "ajaxsearchpro_statistics " . $where . " ORDER BY last_date DESC LIMIT ".($count + 0)
                ,ARRAY_A
            );
        }

        static function clearAll() {
            global $wpdb;

            if (isset($wpdb->base_prefix)) {
                $_prefix = $wpdb->base_prefix;
            } else {
                $_prefix = $wpdb->prefix;
            }

            return $wpdb->query("DELETE FROM " . $_prefix . "ajaxsearchpro_statistics");
        }

        static function deleteKw($id) {
            global $wpdb;

            if (isset($wpdb->base_prefix)) {
                $_prefix = $wpdb->base_prefix;
            } else {
                $_prefix = $wpdb->prefix;
            }

            return $wpdb->query(
                $wpdb->prepare(
                    "DELETE FROM " . $_prefix . "ajaxsearchpro_statistics WHERE id=%d"
                    , ($id+0)
                )
            ) ;
        }
    }
}